<template>
  <v-container>
    <v-breadcrumbs class="px-0" :items="items"></v-breadcrumbs>

    <v-row no-gutters class="d-flex align-center">
      <h1>Novo Cliente</h1>
      <v-spacer></v-spacer>
      <v-btn depressed small color="warning" to="/customers/">VOLTAR</v-btn>
    </v-row>
    <v-divider></v-divider>
    <div id="customers">
      <h2>Preencha o formulário:</h2>

      <v-form v-model="valid">
        <v-container>
          <v-row>
            <v-col cols="12" md="6">
              <v-text-field
                v-model="customer.name"
                :rules="nameRules"
                label="Nome completo"
                required
              ></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field
                v-model="customer.phone"
                v-mask="maskPhone"
                :counter="15"
                label="Telefone"
                required
              ></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="customer.email" :rules="emailRules" label="E-mail" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="customer.cpf_cnpj" label="CPF / CNPJ" required></v-text-field>
            </v-col>

            <v-col cols="12" md="2">
              <v-text-field v-model="customer.cep" label="CEP" v-mask="maskCep" required></v-text-field>
            </v-col>

            <v-col cols="12" md="4">
              <v-text-field v-model="customer.street" label="Rua" required></v-text-field>
            </v-col>

            <v-col cols="12" md="2">
              <v-text-field v-model="customer.number" label="Número" required></v-text-field>
            </v-col>

            <v-col cols="12" md="4">
              <v-text-field v-model="customer.neighborhood" label="Bairro" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="customer.city" label="Cidade" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <v-text-field v-model="customer.state" label="Estado" required></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
              <div>
                Criar conta no App:
                <p>Por padrão é criado automáticamente</p>
                <v-checkbox v-model="customer.account_mobile" label="Não"></v-checkbox>
              </div>
            </v-col>
          </v-row>
          <v-btn depressed color="success" @click="salvar">SALVAR</v-btn>
        </v-container>
      </v-form>
      <v-row>
        <v-spacer></v-spacer>
      </v-row>
    </div>
  </v-container>
</template>

<script>
import axios from "axios";
import { mask } from "vue-the-mask";
export default {
  directives: { mask },
  data: () => ({
    valid: false,
    maskPhone: "(##) ##### ####",
    maskCep: "#####-###",
    customer: {
      name: "",
      phone: "",
      cpf_cnpj: "",
      account_mobile: "",
      email: "",
      street: "",
      cep: "",
      number: "",
      city: "",
      state: "",
      neighborhood: ""
    },
    edit: false,
    cpf_cnpjRules: [v => !!v || "CPF/CNPJ é obrigatório"],
    nameRules: [v => !!v || "Nome é obrigatório"],
    emailRules: [
      v => !!v || "E-mail é obrigatório",
      v => /.+@.+/.test(v) || "E-mail inválido"
    ],
    phoneRules: [v => v.length <= 10 || "Telefone é obrigatório"],
    items: [
      {
        text: "Dashboard",
        disabled: false,
        to: "/"
      },
      {
        text: "Clientes",
        disabled: false,
        exact: true,
        to: "/customers"
      },
      {
        text: "Cadastrar cliente",
        disabled: true
      }
    ]
  }),
  methods: {
    salvar() {
      if (this.edit == false) {
        console.log("criar novo");
        console.log(this.customer);
        axios
          .post("https://young-forest-65938.herokuapp.com/api/v1/customers/", {
            name: this.customer.name,
            phone: this.customer.phone,
            email: this.customer.email,
            cpf_cnpj: this.customer.cpf_cnpj,
            account_mobile: this.customer.account_mobile,
            street: this.customer.street,
            cep: this.customer.cep,
            number: this.customer.number,
            city: this.customer.city,
            state: this.customer.state,
            neighborhood: this.customer.neighborhood
          })
          .then(function(response) {
            console.log(this.customer);
          })
          .catch(function(error) {
            console.log(error);
          });
        this.$router.push("/customers");
      } else {
        console.log("editar else");
        axios
          .put(
            `https://young-forest-65938.herokuapp.com/api/v1/customers/${this.$router.currentRoute.query.id}`,
            {
              name: this.customer.name,
              phone: this.customer.phone,
              email: this.customer.email,
              cpf_cnpj: this.customer.cpf_cnpj,
              account_mobile: this.customer.account_mobile,
              street: this.customer.street,
              cep: this.customer.cep,
              number: this.customer.number,
              city: this.customer.city,
              state: this.customer.state,
              neighborhood: this.customer.neighborhood
            }
          )
          .then(function(response) {
            console.log(this.customer);
          })
          .catch(function(error) {
            console.log(error);
          });
        this.$router.push("/customers");
      }
    }
  },
  mounted() {
    console.log(this.$router.currentRoute.query.id);
    if (this.$router.currentRoute.query.id != null) {
      this.edit = true;
      console.log(this.$router.currentRoute.query.id);
      console.log("if mounted");
      return axios
        .get(
          `https://young-forest-65938.herokuapp.com/api/v1/customer/${this.$router.currentRoute.query.id}`
        )
        .then(response => {
          var resp = response.data;
          this.customer = resp.data;
          console.log(this.customer);
        });
    }
  }
};
</script>
